# coding=UTF-8
from flask import Flask,render_template,request
#import feature_extraction
import read_fasta_sequences
import numpy as np
import pandas as pd
import joblib
#import feature_selection
import one_hot_encoding
import prediction_function

import sys,re
from check_sequences import *
from sklearn.preprocessing import QuantileTransformer  #cff



# initialize flask application
app = Flask(__name__)

@app.route('/')
def main():
    return render_template('main.html')  #


@app.route('/submit',methods=("GET", "POST"))
def predict():
    if request.method == "POST":
        sequencedata = request.form["sequence"]  #input form
        fastas, sequence_name = read_fasta_sequences.read_protein_sequences(sequencedata) 
        #fastas: list, contains several lists (one seqence one list), each list includes seqence name/ID and sequence
        #sequence_name: list, contains sequence names/ID
        check=check_sequences(sequencedata, fastas)
        if check == False: 
            #False: seq_len < 40 or seq name not starting with >
            return render_template('main2.html')  
        #display in the input form: Please input correct FASTA format protein sequence！！
        else:
            
            encondings = one_hot_encoding.seq_encoding(fastas)  # encodings contain sequence names and encoded sequences
            
            results = prediction_function.predicting(encondings, model_path='models/models/trained_model.json', weight_path='models/weights/weights.h5')
            
            results = results.to_numpy()
            
            
            return render_template('result.html', Fasta=sequencedata, result=results, Predicting="Output results ")
        
        

if __name__=="__main__":
    app.run(debug=True)


