#!/usr/bin/env python
# coding: utf-8

# In[ ]:

import re
import os
import pickle
import numpy as np
import linecache

import pandas as pd
from keras.preprocessing import sequence


def trans(seq):
    '''把序列字符串转换成digital列表。
    20中氨基酸转化为1-20
    其他特殊的氨基酸，均转化成0
    
    '''
    a = []
    dic = {'A':1,'C':2,'D':3,'E':4,'F':5,'G':6,'H':7,'I':8,'K':9,'L':10,'M':11,'N':12,'P':13,'Q':14,'R':15,'S':16,'T':17,'V':18,'W':19,'Y':20}
    
    return [dic.get(str.upper(seq[i])) if str.upper(seq[i]) in list(dic.keys()) else 0 for i in range(len(seq))]


def seq_encoding(data):
    '''input: sequence information, containing sequence name and sequence
    output: numpy.ndarray. 
    
    
    '''
    seq_names = []
    seq_digits = []
    for i in data:  #each seq (seq info and seq) in the data 
        name, seq = i[0], re.sub('-', '', i[1])
        
        seq = seq.strip(' \t\r\n')
        seq_digits.append(trans(seq))
        
        seq_names.append(name)
        
    t = (seq_names, seq_digits)
    return t
