#!/usr/bin/env python
# coding: utf-8


import re
import pickle
import pandas as pd
import numpy as np

import itertools

import math 
import h5py
import json
import math
#import time

import keras
from keras.models import Model
from keras.models import model_from_json
import tensorflow as tf
from keras.models import load_model
#from keras.preprocessing import image
from keras.applications.imagenet_utils import preprocess_input
from keras.preprocessing import sequence


#from sklearn.preprocessing import label_binarize
#from itertools import cycle
from scipy import interp




def load_model(path1, path2):
    json_file = open(path1,'r')
    loaded_model_json = json_file.read()
    json_file.close()
    loaded_model = model_from_json(loaded_model_json)
    
    loaded_model.load_weights(path2)
    
    return loaded_model




def predicting(encoded_data, model_path, weight_path, batch_size=128,  
               label_value_dict = {0:"non-DNA/RNA-binding protein",   
                                     #non DNA/RNA-binding protein (non-NABP)
                                1: "DNA-binding protein" ,    
                                     #DNA-binding  (RBP)
                                2: "RNA-binding protein" ,    
                                     #RNA-binding  (DBP)
                                3: "DNA- and RNA-binding protein" }
                                    # DRBP  
                         ):
    '''X: validation encoded seq data
       y: true label of validation data'''
    
    #with open(encoded_path, "rb") as f:  
        #seq_digits, labels_0, labels_1, labels_2, labels_3 = pickle.load(f)
    sequence_name, X = encoded_data
    
    X = sequence.pad_sequences(X, maxlen=1000, padding="post", truncating="post")
    X = pd.DataFrame(X)
    #y = pd.DataFrame([labels_0, labels_1, labels_2, labels_3]).T
    
    
    model = load_model(model_path, weight_path)
    
    #print("The probality value of each sample:")
    y_prob = model.predict(X, batch_size=batch_size) #返回样本属于每一个类别的概率值
    #print(y_prob)  #概率值
 
    
    #print("The predicted label value (int) of each sample:")
    y_int = model.predict_classes(X, batch_size=batch_size).astype('int')  ##类别值 0，1，2,3 #np.array
   
    #print(y_int) 
    
    
    df_out = pd.DataFrame(np.zeros((y_int.shape[0], 2)),
                         columns=[ "Sequence name", "Prediction"])
            
    for i in range(y_int.shape[0]):
        df_out.iloc[i, 0] = str(sequence_name[i])
        df_out.iloc[i, 1] = label_value_dict[y_int[i]]
        #df_out.iloc[i, 2] = "%.2f%%" % (y_prob[i, y_int[i]] * 100)
        
                
    #results = df_out.to_numpy()
   
    
    return df_out
